## pgpointcloud 1.2.1

=== Makefile ===

all install uninstall noop clean distclean:
	$(MAKE) -C lib $@
	$(MAKE) -C pgsql $@
	$(MAKE) -C pgsql_postgis $@

check:
	$(MAKE) -C lib $@

installcheck:
	$(MAKE) -C pgsql $@

astyle:
	find . \
	  -name "*.c" \
	  -type f \
	  -or \
	  -name "*.h" \
	  -type f \
	  -exec astyle --style=ansi --indent=tab --suffix=none {} ';'

maintainer-clean:
	rm -f config.log config.mk config.status lib/pc_config.h configure
	rm -rf autom4te.cache build

=== lib/Makefile ===

include ../config.mk

CPPFLAGS = $(XML2_CPPFLAGS) $(ZLIB_CPPFLAGS) $(LAZPERF_CPPFLAGS)
LDFLAGS = $(XML2_LDFLAGS) $(ZLIB_LDFLAGS)
CFLAGS += -fPIC

OBJS = \
	pc_bytes.o \
	pc_dimstats.o \
	pc_filter.o \
	pc_mem.o \
	pc_patch.o \
	pc_patch_dimensional.o \
	pc_patch_uncompressed.o \
	pc_point.o \
	pc_pointlist.o \
	pc_schema.o \
	pc_sort.o \
	pc_stats.o \
	pc_util.o \
	pc_val.o \
	stringbuffer.o \
	hashtable.o \
	pc_patch_lazperf.o

OBJS_LAZPERF = \
	lazperf_adapter.o

all: $(LIB_A) $(LIB_A_LAZPERF)
	$(MAKE) -C cunit $@

$(LIB_A): $(OBJS)
	ar rs $@ $^

$(LIB_A_LAZPERF): $(OBJS_LAZPERF)
	ar rs $@ $^

clean:
	@rm -f $(OBJS) $(LIB_A) $(OBJS_LAZPERF) $(LIB_A_LAZPERF)
	$(MAKE) -C cunit $@

install:
	@echo "No install target in lib"

check:
	$(MAKE) -C cunit $@

=== pgsql_postgis/Makefile ===
# pointcloud

include ../config.mk

#MODULE_big = pointcloud_postgis
#OBJS =
SED = sed
EXTENSION = pointcloud_postgis
EXTVERSION=$(shell cat ../Version.config)
DATA_built = \
  $(EXTENSION).control \
  $(EXTENSION)--$(EXTVERSION).sql

#REGRESS = pointcloud

# Add in build/link flags for lib
#PG_CPPFLAGS += -I../lib
#SHLIB_LINK += $(filter -lm, $(LIBS)) $(XML2_LDFLAGS) $(ZLIB_LDFLAGS) ../lib/$(LIB_A)

# We are going to use PGXS for sure
include $(PGXS)

$(EXTENSION).control: $(EXTENSION).control.in Makefile
	$(SED) -e 's/@POINTCLOUD_VERSION@/$(EXTVERSION)/' $< > $@

$(EXTENSION)--$(EXTVERSION).sql: $(EXTENSION).sql.in Makefile
	$(SED) -e 's/@POINTCLOUD_VERSION@/$(EXTVERSION)/' $< > $@

=== debian/changelog ===
pgpointcloud (1.2.1-8) unstable; urgency=medium

  * Upload for PostgreSQL 14.

 -- Christoph Berg <myon@debian.org>  Wed, 20 Oct 2021 13:15:15 +0200

pgpointcloud (1.2.1-7) unstable; urgency=medium

  [ Christian Ehrhardt ]
  * Ignore build time regression test results on armhf

 -- Christoph Berg <myon@debian.org>  Wed, 02 Dec 2020 16:42:22 +0100

pgpointcloud (1.2.1-6) unstable; urgency=medium

  * Ignore regression test results on armhf. (Closes: #974869)

 -- Christoph Berg <myon@debian.org>  Mon, 23 Nov 2020 12:10:16 +0100

pgpointcloud (1.2.1-5) unstable; urgency=medium

  * Ignore regression test results on big-endian.
    https://github.com/pgpointcloud/pointcloud/issues/278

 -- Christoph Berg <myon@debian.org>  Sat, 31 Oct 2020 23:06:59 +0100

pgpointcloud (1.2.1-4) unstable; urgency=medium

  * Run test also at build-time.

 -- Christoph Berg <myon@debian.org>  Wed, 28 Oct 2020 22:06:38 +0100

pgpointcloud (1.2.1-3) unstable; urgency=medium

  * Upload for PostgreSQL 13.
  * Catch test output variation on 32bit platforms.
  * R³: no.
  * DH 13.
  * debian/tests: Use 'make' instead of postgresql-server-dev-all.

 -- Christoph Berg <myon@debian.org>  Mon, 19 Oct 2020 13:00:13 +0200

pgpointcloud (1.2.1-2) unstable; urgency=medium

  * Mention all copyright holders in debian/copyright.

 -- Christoph Berg <myon@debian.org>  Sun, 12 Apr 2020 13:16:09 +0200

pgpointcloud (1.2.1-1) unstable; urgency=medium

  * Initial release.

 -- Christoph Berg <myon@debian.org>  Wed, 08 Jan 2020 16:41:48 +0100

=== debian/control ===
Source: pgpointcloud
Section: database
Priority: optional
Maintainer: Debian PostgreSQL Maintainers <team+postgresql@tracker.debian.org>
Uploaders: Christoph Berg <myon@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-autoreconf | debhelper-compat (= 13),
 libxml2-dev,
 postgresql-all (>= 219~),
 zlib1g-dev,
Standards-Version: 4.5.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/postgresql/pgpointcloud
Vcs-Git: https://salsa.debian.org/postgresql/pgpointcloud.git
Homepage: https://github.com/pgpointcloud/pointcloud

Package: postgresql-14-pointcloud
Architecture: any
Depends: postgresql-14, ${misc:Depends}, ${shlibs:Depends}
Description: PostgreSQL extension for storing point cloud (LIDAR) data
 LIDAR sensors quickly produce millions of points with large numbers of
 variables measured on each point. The challenge for a point cloud database
 extension is efficiently storing this data while allowing high fidelity access
 to the many variables stored.
 .
 Much of the complexity in handling LIDAR comes from the need to deal with
 multiple variables per point. The variables captured by LIDAR sensors varies
 by sensor and capture process. Some data sets might contain only X/Y/Z values.
 Others will contain dozens of variables: X, Y, Z; intensity and return number;
 red, green, and blue values; return times; and many more. There is no
 consistency in how variables are stored: intensity might be stored in a 4-byte
 integer, or in a single byte; X/Y/Z might be doubles, or they might be scaled
 4-byte integers.
 .
 PostgreSQL Pointcloud deals with all this variability by using a "schema
 document" to describe the contents of any particular LIDAR point. Each point
 contains a number of dimensions, and each dimension can be of any data type,
 with scaling and/or offsets applied to move between the actual value and the
 value stored in the database. The schema document format used by PostgreSQL
 Pointcloud is the same one used by the PDAL library.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

VERSIONS=$(shell pg_buildext supported-versions)

override_dh_auto_configure:
	# nothing to do here, see override_dh_auto_install instead

override_dh_auto_build:
	# nothing to do here, see override_dh_auto_install instead

override_dh_auto_test:
	# nothing to do here, see debian/tests/* instead

override_dh_auto_install:
	+set -eux; for v in $(VERSIONS); do \
	  [ -f pgsql/Makefile ] && $(MAKE) -C pgsql distclean; \
	  dh_auto_configure -- --with-pgconfig=/usr/lib/postgresql/$$v/bin/pg_config GITCMD=false; \
	  $(MAKE); \
	  $(MAKE) install DESTDIR=$(CURDIR)/debian/postgresql-$$v-pointcloud; \
	done

override_dh_installdocs:
	dh_installdocs --all README.*

override_dh_pgxs_test:
	for v in $(shell pg_buildext supported-versions); do \
	  PG_CONFIG=/usr/lib/postgresql/$$v/bin/pg_config; \
	  if ! pg_virtualenv -p postgresql-%v-pointcloud -v $$v \
		 make -C pgsql installcheck \
		   PG_CONFIG=$$PG_CONFIG \
		   PGXS=$$($$PG_CONFIG --pgxs) \
		   PGSQL_MAJOR_VERSION=$${v%.*} \
		   LAZPERF_STATUS=disabled; then \
		 echo "*** pgsql/regression.diffs ***"; \
		 cat pgsql/regression.diffs; \
		 if [ $(DEB_HOST_ARCH_ENDIAN) != big ] && [ $(DEB_HOST_ARCH) != armhf ]; then exit 1; fi; \
	  fi; \
	done

override_dh_auto_clean:
	touch config.mk
	dh_auto_clean

%:
	dh $@ --with autoreconf,pgxs

=== debian/tests/control ===
Depends: make, @
Tests: installcheck
Restrictions: allow-stderr

## pgpointcloud 1.2.4

=== pgsql_postgis/Makefile ===
--- 
+++ 
@@ -7,10 +7,20 @@
 SED = sed
 EXTENSION = pointcloud_postgis
 EXTVERSION=$(shell cat ../Version.config)
+
+UPGRADABLE = 1.1.0 1.1.1 1.2.0 1.2.1 1.2.2 1.2.3
+UPGRADES = \
+  $(shell echo $(UPGRADABLE) | \
+     $(SED) 's/^/$(EXTENSION)--/' | \
+     $(SED) 's/$$/--$(EXTVERSION).sql/' | \
+     $(SED) 's/ /--$(EXTVERSION).sql $(EXTENSION)--/g') \
+  $(EXTENSION)--$(EXTVERSION)--$(EXTVERSION)next.sql \
+  $(EXTENSION)--$(EXTVERSION)next--$(EXTVERSION).sql
+
 DATA_built = \
   $(EXTENSION).control \
-  $(EXTENSION)--$(EXTVERSION).sql
-
+  $(EXTENSION)--$(EXTVERSION).sql \
+  $(UPGRADES)
 #REGRESS = pointcloud
 
 # Add in build/link flags for lib
@@ -25,3 +35,10 @@
 
 $(EXTENSION)--$(EXTVERSION).sql: $(EXTENSION).sql.in Makefile
 	$(SED) -e 's/@POINTCLOUD_VERSION@/$(EXTVERSION)/' $< > $@
+
+# NOTE: relies on PERL being defined by PGXS
+$(EXTENSION)--%--$(EXTVERSION).sql: $(EXTENSION)--$(EXTVERSION).sql ../util/proc_upgrade.pl
+	cat $< | ../util/proc_upgrade.pl > $@
+
+$(EXTENSION)--%--$(EXTVERSION)next.sql: $(EXTENSION)--$(EXTVERSION)next--$(EXTVERSION).sql
+	ln -f $< $@

=== lib/cunit/Makefile ===

include ../../config.mk

CPPFLAGS = $(XML2_CPPFLAGS) $(CUNIT_CPPFLAGS) $(ZLIB_CPPFLAGS) -I..
LDFLAGS = $(XML2_LDFLAGS) $(CUNIT_LDFLAGS) $(ZLIB_LDFLAGS)

EXE = cu_tester

# ADD YOUR NEW TEST FILE HERE (1/1)
OBJS =	\
	cu_tester.o \
	cu_pc_bytes.o \
	cu_pc_schema.o \
	cu_pc_point.o \
	cu_pc_patch.o \
	cu_pc_patch_lazperf.o \
	cu_pc_sort.o \
	cu_pc_util.o

ifeq ($(CUNIT_LDFLAGS),)
# No cunit? Emit message and continue

all:
	@echo "CUnit not found, skipping build"

check:
	@echo "CUnit not found, skipping tests"

else
# Yes cunit? Build tests and run

# Build the unit tester
all: $(EXE)

# Build and run the unit tester
check: $(EXE)
	@./$(EXE)

endif

# Build the main unit test executable
$(EXE): $(OBJS) ../$(LIB_A) ../$(LIB_A_LAZPERF)
	$(CC) -o $@ $^ $(LDFLAGS) -lm -lstdc++

../$(LIB_A):
	$(MAKE) -C .. $(LIB_A)

../$(LIB_A_LAZPERF):
	$(MAKE) -C .. $(LIB_A_LAZPERF)

# Clean target
clean:
	@rm -f $(OBJS)
	@rm -f $(EXE)

=== debian/changelog ===
pgpointcloud (1.2.4-2) unstable; urgency=medium

  * Upload for PostgreSQL 15.

 -- Christoph Berg <myon@debian.org>  Mon, 24 Oct 2022 13:59:14 +0200

pgpointcloud (1.2.4-1) unstable; urgency=medium

  * New upstream version.
  * Update watch file to look at github tags.

 -- Christoph Berg <myon@debian.org>  Mon, 26 Sep 2022 14:48:58 +0200

pgpointcloud (1.2.3-1) unstable; urgency=medium

  * New upstream version.
  * Fix use-after-free in SPI_connect code.

 -- Christoph Berg <myon@debian.org>  Mon, 12 Sep 2022 12:58:39 +0200

=== debian/control ===
--- 
+++ 
@@ -9,15 +9,15 @@
  libxml2-dev,
  postgresql-all (>= 219~),
  zlib1g-dev,
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/postgresql/pgpointcloud
 Vcs-Git: https://salsa.debian.org/postgresql/pgpointcloud.git
 Homepage: https://github.com/pgpointcloud/pointcloud
 
-Package: postgresql-14-pointcloud
+Package: postgresql-15-pointcloud
 Architecture: any
-Depends: postgresql-14, ${misc:Depends}, ${shlibs:Depends}
+Depends: postgresql-15, ${misc:Depends}, ${shlibs:Depends}
 Description: PostgreSQL extension for storing point cloud (LIDAR) data
  LIDAR sensors quickly produce millions of points with large numbers of
  variables measured on each point. The challenge for a point cloud database

## pgpointcloud 1.2.5

=== Makefile ===
--- 
+++ 
@@ -19,6 +19,6 @@
 	  -type f \
 	  -exec astyle --style=ansi --indent=tab --suffix=none {} ';'
 
-maintainer-clean:
+maintainer-clean: clean
 	rm -f config.log config.mk config.status lib/pc_config.h configure
 	rm -rf autom4te.cache build

=== doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build
DATE=$(shell date +'%y.%m.%d %H:%M:%S')

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest doxygen

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  pdf        to make PDF files"
	@echo "  man        to make manual pages"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*
	-rm -rf doxygen/xml*;
	-rm -rf doxygen/html*;

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@touch $(BUILDDIR)/html/.nojekyll
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	make -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

pdf:
	$(SPHINXBUILD) -b pdf $(ALLSPHINXOPTS) $(BUILDDIR)/pdf
	@echo
	@echo "Build finished. The PDF files are in _build/pdf."

=== lib/Makefile ===
--- 
+++ 
@@ -40,9 +40,8 @@
 	@rm -f $(OBJS) $(LIB_A) $(OBJS_LAZPERF) $(LIB_A_LAZPERF)
 	$(MAKE) -C cunit $@
 
-install:
+install uninstall:
 	@echo "No install target in lib"
 
 check:
 	$(MAKE) -C cunit $@
-

=== pgsql_postgis/Makefile ===
--- 
+++ 
@@ -8,7 +8,7 @@
 EXTENSION = pointcloud_postgis
 EXTVERSION=$(shell cat ../Version.config)
 
-UPGRADABLE = 1.1.0 1.1.1 1.2.0 1.2.1 1.2.2 1.2.3
+UPGRADABLE = 1.1.0 1.1.1 1.2.0 1.2.1 1.2.2 1.2.3 1.2.4
 UPGRADES = \
   $(shell echo $(UPGRADABLE) | \
      $(SED) 's/^/$(EXTENSION)--/' | \

=== debian/changelog ===
pgpointcloud (1.2.5-3) unstable; urgency=medium

  * Upload for PostgreSQL 18.
  * Add ${postgresql:Breaks}.
  * debian/tests: Depend on postgresql-common-dev instead of 'make'.

 -- Christoph Berg <myon@debian.org>  Tue, 30 Sep 2025 16:14:28 +0200

pgpointcloud (1.2.5-2) unstable; urgency=medium

  * Upload for PostgreSQL 17.
  * Restrict to 64-bit architectures.
  * Mark postgresql-all as <!nocheck>.
  * Revert usage of ${postgresql:Depends}.

 -- Christoph Berg <myon@debian.org>  Tue, 24 Sep 2024 17:54:40 +0200

pgpointcloud (1.2.5-1) unstable; urgency=medium

  * New upstream version.
  * Upload for PostgreSQL 16.
  * Use ${postgresql:Depends}.

 -- Christoph Berg <myon@debian.org>  Wed, 20 Sep 2023 09:56:17 +0200

=== debian/control ===
--- 
+++ 
@@ -2,22 +2,29 @@
 Section: database
 Priority: optional
 Maintainer: Debian PostgreSQL Maintainers <team+postgresql@tracker.debian.org>
-Uploaders: Christoph Berg <myon@debian.org>,
+Uploaders:
+ Christoph Berg <myon@debian.org>,
 Build-Depends:
  debhelper-compat (= 13),
  dh-autoreconf | debhelper-compat (= 13),
+ architecture-is-64-bit <!pkg.postgresql.32-bit>,
  libxml2-dev,
- postgresql-all (>= 219~),
+ postgresql-all <!nocheck>,
+ postgresql-server-dev-all,
  zlib1g-dev,
-Standards-Version: 4.6.1
-Rules-Requires-Root: no
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/postgresql/pgpointcloud
 Vcs-Git: https://salsa.debian.org/postgresql/pgpointcloud.git
 Homepage: https://github.com/pgpointcloud/pointcloud
 
-Package: postgresql-15-pointcloud
+Package: postgresql-18-pointcloud
 Architecture: any
-Depends: postgresql-15, ${misc:Depends}, ${shlibs:Depends}
+Depends:
+ postgresql-18,
+ ${misc:Depends},
+ ${shlibs:Depends},
+Breaks:
+ ${postgresql:Breaks},
 Description: PostgreSQL extension for storing point cloud (LIDAR) data
  LIDAR sensors quickly produce millions of points with large numbers of
  variables measured on each point. The challenge for a point cloud database

=== debian/rules ===
--- 
+++ 
@@ -25,6 +25,7 @@
 	dh_installdocs --all README.*
 
 override_dh_pgxs_test:
+	set -ex; \
 	for v in $(shell pg_buildext supported-versions); do \
 	  PG_CONFIG=/usr/lib/postgresql/$$v/bin/pg_config; \
 	  if ! pg_virtualenv -p postgresql-%v-pointcloud -v $$v \

=== debian/watch ===
version=4
https://github.com/pgpointcloud/pointcloud/tags .*/v(.*).tar.gz
